/*
	BitmapDissolveApp.as
	Lee Felarca
	http://www.zeropointnine.com/blog
	4-7-2007
	v0.8
	
	Source code licensed under a Creative Commons Attribution 3.0 License.
	http://creativecommons.org/licenses/by/3.0/
	Some Rights Reserved.
*/

package
{
	import BitmapDissolve;
	import BitmapDissolveEvent;
	import flash.display.*;
	import flash.net.URLRequest;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.EventDispatcher;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	public class BitmapDissolveApp extends Sprite
	{
		private var DEBUG:Boolean = true;
		
		private var STAGEWIDTH:int = stage.stageWidth;
		private var STAGEHEIGHT:int = stage.stageHeight;
		
		private var imgMain:Bitmap;
		private var bmpMain:BitmapData;
		private var ldr:Loader;
		private var lnrId:Object = new Object; 
		private var bd1:BitmapDissolve;

		private var num:Number = -1;
		
		private var tfDebug:TextField;
		
		var path:Array = 		["BitmapDissolve_ipoods.jpg", "BitmapDissolve_ipoods.jpg", "BitmapDissolve_ipoods.jpg", "BitmapDissolve_09b2.png"];
		var bkgCol:Array =  	[0x000000, 		0x000000, 	0x000000,	0xFF0000];
		var twoX:Array =		[false,			true,		true,		false];
		var numPx:Array = 		[600,			500,		600,		200];
		var dur:Array = 		[15,			20,			30,			30];
		var dir:Array = 		[BitmapDissolve.DIR_UP,	BitmapDissolve.DIR_DOWN, BitmapDissolve.DIR_RIGHT, BitmapDissolve.DIR_LEFT];
		var distrib:Array = 	[BitmapDissolve.DISTRIB_FLAT, BitmapDissolve.DISTRIB_FLAT,	BitmapDissolve.DISTRIB_CONCAVE, BitmapDissolve.DISTRIB_FLAT];

		
		public function BitmapDissolveApp():void
		{
			init();
		}

		private function init():void
		{
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			stage.frameRate = 60;
			
			// set up loader			
			ldr = new Loader();
			ldr.contentLoaderInfo.addEventListener(Event.COMPLETE, onLoadComplete);
			
			// setup debug textfield
			if (DEBUG) {
				tfDebug = new TextField();
				addChild(tfDebug);
			}

			showNext(null);
		}

		private function showNext(e:Event):void
		{
			num++;
			if (num == path.length) num = 0;

			ldr.load(new URLRequest( path[num] ));
		}

		private function onLoadComplete(e:Event):void
		{
			imgMain = Bitmap(ldr.content);
			bmpMain = imgMain.bitmapData;

			if (bd1) {
				bd1.stop();
				removeChild(bd1);
			}
			
			bd1 = new BitmapDissolve(bmpMain, uint(bkgCol[num]));
			bd1.addEventListener(BitmapDissolveEvent.DISSOLVED, onDissolve);
			bd1.addEventListener(MouseEvent.MOUSE_DOWN, showNext);
			bd1.buttonMode = true;

			bd1.distribType = distrib[num];
			bd1.doubleSpeed = twoX[num];
			bd1.numPixels = numPx[num];
			bd1.direction = dir[num];
			bd1.duration = dur[num];
			bd1.x = int( (STAGEWIDTH - bmpMain.width) / 2 );
			bd1.y = int( (STAGEHEIGHT - bmpMain.height) / 2 );

			addChild(bd1);

			bd1.run();
		}
		
		private function onDissolve(e:BitmapDissolveEvent):void
		{
			if (DEBUG) {
				tfDebug.text = (Math.floor(e.fps * 100) / 100).toString() + " fps";
				tfDebug.setTextFormat( new TextFormat("Tahoma",9,0x888888));
				trace(e.milliseconds + " " + e.frames + " " + e.fps);
			}

			showNext(null);
		}		
				
	}
}